package ims.io;

import ims.data.ISentence;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;

public class TabbedWriter implements SentenceWriter {
	
	private final BufferedWriter out;
	
	public TabbedWriter(File output) throws UnsupportedEncodingException, FileNotFoundException{
		this.out=new BufferedWriter(new OutputStreamWriter(new FileOutputStream(output),"utf8"));
	}

	public void write(ISentence s) throws IOException {
		String x=s.getTabbedToString();
		out.write(x);
		out.newLine();
		out.newLine();
		out.flush();
	}

	public void close() throws IOException {
		out.close();
	}

}
