package ims.oracle;

import ims.oracle.Configuration.TR;

import java.util.ArrayList;
import java.util.List;

public abstract class AbstractDynamicOracle extends IOracle {
	protected final TR[] myTRs;
	
	protected AbstractDynamicOracle(TR[] myTRs){
		this.myTRs=myTRs;
	}

	@Override
	public List<TR> getActions(IConfiguration c, int[] heads) {
		List<TR> r=new ArrayList<TR>();
		for(TR tr:myTRs){
			if(isCorrectULBLTransition(tr,c,heads))
				r.add(tr);
		}
		return r;
	}
	
	@Override
	public boolean isDynamic(){
		return true;
	}

}
