package ims.oracle;

import ims.oracle.Configuration.TR;
import ims.trans.Options;
import ims.trans.Options.TransitionSystem;

import java.util.List;

public class DynamicArcStandardOracle extends AbstractDynamicOracle{

//	@Override
//	public boolean isPermissible(IConfiguration c, TR tr, int[] heads) {
//		switch(tr){
//		case SH:  return canShift(heads,c);
//		case LA:  return canLeftArc(heads,c);
//		case RAS: return canRightArcS(heads,c);
//		default:  throw new UnsupportedOperationException("!");
//		}
//	}

	protected DynamicArcStandardOracle(TR[] myTRs) {
		super(myTRs);
	}

//	@Override
//	List<TR> getActions(IConfiguration c,int[] heads) {
//		List<TR> actions=new ArrayList<TR>();
//		if(canShift(heads,c))
//			actions.add(TR.SH);
//		if(canLeftArc(heads,c))
//			actions.add(TR.LA);
//		if(canRightArcS(heads,c))
//			actions.add(TR.RAS);
//		return actions;
//	}

	static boolean canShift(int[] heads,IConfiguration c){
		if(true) //XXX
			return BruteForceShiftOKCheck.canShift(c, null, heads);
		
		
		//Another way of expressing this is simply:
		//If we cannot leftarc, then we have to shift (since {SH,LA} is the only possible ambiguity in the system)
		//If we can leftarc, shift is OK is b0 is dominated by s0
		
		
		//This is the old version
		if(c.bufferSize()==0)
			return false;
		int stackTop=c.peekStack(0);
		if(!c.hasAllRightDeps(stackTop))
			return true;
		if(heads[stackTop]>stackTop && c.hasAllDeps(stackTop)) //used to be this
//		if(heads[stackTop]>stackTop && c.hasAllLeftDeps(stackTop)) //c has all left deps is enough, since we already tested for right deps above
			return true;
		return false;
	}
	
	static boolean canRightArcS(int[] heads,IConfiguration c){
		if(!c.hasMinTwoStackElements())
			return false;
		int stackTop=c.peekStack(0);
		int stackSecond=c.peekStack(1);
		if(heads[stackTop]==stackSecond && c.hasAllDeps(stackTop))
			return true;
		else
			return false;
	}

	static boolean canLeftArc(int[] heads,IConfiguration c){
		if(!c.hasMinTwoStackElements())
			return false;
		int stackTop=c.peekStack(0);
		int stackSecond=c.peekStack(1);
//		if(heads[stackSecond]==stackTop && c.hasAllDeps(stackSecond)) //Used to be this
//		if(heads[stackSecond]==stackTop && c.hasAllLeftDeps(stackSecond)) //Clearly, by projectivity, stackSecond must have all it's right dependents if stackSecond is the dependent of stackTop 
		if(heads[stackSecond]==stackTop) //Also, if stackSecond have remaining deps to the left, and we are in a position to do leftarc, then those left dependents cannot be attached (since stackSecond will not come back to the top of the stack), so we must have made a mistake earlier 
			return true;
		else
			return false;
	}

	private final IOracle deterministicOracle=OracleFactory.getStaticOracle(Options.TransitionSystem.ArcS);
	
	@Override
	public List<String> getCanonicalSequence(int[] heads, String[] labels,boolean labeled) {
		return deterministicOracle.getCanonicalSequence(heads, labels, labeled);
	}

	@Override
	public boolean canDoNonProj() {
		return false;
	}

	@Override
	public boolean isCorrectULBLTransition(TR tr, IConfiguration conf, int[] heads) {
		switch(tr){
		case LA:  return canLeftArc(heads,conf);
		case RAS: return canRightArcS(heads,conf);
		case SH:  return canShift(heads,conf);
		default:  throw new Error("not supposrted");
		}
	}

	@Override
	public void initSentence(int[] heads) {
		
	}
	
	@Override
	public TransitionSystem getTS() {
		return TransitionSystem.ArcS;
	}
	
}
