package ims.oracle;

import ims.data.Stack;

public interface IConfiguration {

	public static final char STATE_SIG_SEPARATOR=513; //This should be safe enough, since we assume all sentences are shorter than 256
	
	public int sentenceSize();
	public int bufferSize();
	public int stackSize();
	public boolean hasMinTwoStackElements();
	public int peekBuffer(int d);
	public int peekStack(int d);
	public int getHead(int d);
	public int getLbl(int i);
	public boolean hasHead(int dep);
	public boolean hasAllDeps(int head);
	public boolean hasAllLeftDeps(int head);
	public boolean hasAllRightDeps(int head);
	
	public TokenState getTokenState(int i);
	public int getBufferNoPushedBack();
	
	public enum TokenState {
		OnStack(true,false),
		OnBuffer(false,true),
		Gone(false,false);
		
		public final boolean onStack;
		public final boolean onBuffer;
		TokenState(boolean onStack,boolean onBuffer){
			this.onStack=onStack;
			this.onBuffer=onBuffer;
		}
	}

	public String getTransitionSeqSignature();
	public StringBuilder appendStackSig(StringBuilder sb);
	public String getULBLStateSig();
	public String getLBLStateSig();
	public int getRemainingDeps(int head);
	public Stack getStackCopy();
	
	public int getTotalTransitions();
}
