package ims.oracle;

import java.util.List;

import ims.data.ISentence;
import ims.data.Instance;
import ims.hotcoref.symbols.StringSymbolMapping;
import ims.oracle.Configuration.TR;
import ims.trans.Options.TransitionSystem;

public abstract class IOracle {
	
	protected int curIter=0;
	
	public abstract List<String> getCanonicalSequence(int[] heads,String[] labels,boolean labeled);
	public abstract boolean canDoNonProj();
	public abstract boolean isDynamic();
	public abstract boolean isCorrectULBLTransition(TR tr,IConfiguration conf,int[] heads);
	public abstract void initSentence(int[] heads);
	public abstract List<TR> getActions(IConfiguration c, int[] heads);
	public abstract TransitionSystem getTS();
	
	public List<String> getCanonicalSequence(ISentence s,boolean labeled){
		return getCanonicalSequence(s.getTrainHeads(),s.getTrainLabels(),labeled);
	}
	
	public int[] establishTransitionMappingAndGetCanonicalSequence(ISentence s,StringSymbolMapping transitions,boolean labeled) {
		List<String> sequence=getCanonicalSequence(s,labeled);
		int[] r=new int[sequence.size()];
		int i=0;
		for(String op:sequence){
			int t=transitions.lookup(op);
			r[i]=t;
			++i;
		}
		return r;
	}
	
	public void initSentence(Instance inst){
		initSentence(inst.head);
	}

	public void nextIter(){
		curIter++;
	}
	
}
