package ims.trans;

import java.io.Serializable;

import ims.data.Instance;
import ims.hotcoref.symbols.AbstractSymbolMapping;
import ims.hotcoref.symbols.SymbolTable;
import ims.perceptron.Long2IntInterface;
import ims.perceptron.ParametersFloat;

public abstract class FeatureExtractor implements Serializable{
	private static final long serialVersionUID = 3521203190028337055L;

	public static final int NONE=AbstractSymbolMapping.NONE_IDX;
	public static final int[] NONE_ARR=new int[]{AbstractSymbolMapping.NONE_IDX};
//	public static final int SINK_MIN_SIZE=10000;
	
	public final long[] sink=new long[Options.featureSinkSize];
	
	protected final int
		bF, //Bits for form and lemma
		bT, //Bits for pos tag
		bM, //Bits for morphology
		bL, //Bits for deprels
		bS; //Bits for supertags
	protected final int bA; //Bits for actions
	
	protected final int 
		bD; //bits for dist
	
	public FeatureExtractor(int bF,int bT,int bM,int bA,int bL,int bS){
		this.bF=bF;
		this.bT=bT;
		this.bM=bM;
		this.bA=bA;
		this.bL=bL;
		this.bS=bS;
		this.bD=BITS_BUCKETS;
	}
	
	public static final int BITS_BUCKETS=5;
	public static int getIntBucket(int i){
		if(i<0)
			return 0;
		if(i==0)
			return 1;
		if(i==1)
			return 2;
		if(i==2)
			return 3;
		if(i==3)
			return 4;
		if(i<6)
			return 5;
		if(i<10)
			return 6;
		if(i<20)
			return 7;
		return 8;
	}
	
	public abstract int extractFeatures(State s,long[] sink,Instance inst);

	public void initWeights(SymbolTable symTab,ParametersFloat parameters,Long2IntInterface l2i) {
		//Do nothings
	}
	
}
