package ims.trans;

import java.util.Collections;
import java.util.List;

import ims.data.Instance;
import ims.hotcoref.symbols.SymbolTable;
import ims.oracle.IOracle;
import ims.perceptron.Long2IntInterface;
import ims.perceptron.ParametersFloat;
import ims.trans.transitions.ITransition;
import ims.trans.transitions.ITransitionFilter;

public class StaticOracleTrainer extends AbstractBeamTrainer {
	
	public StaticOracleTrainer(Options options, SymbolTable symTab,	IOracle oracle, ITransitionFilter transitionFilter,	List<Instance> instances, FeatureExtractor featureExtractor, Long2IntInterface l2i, ParametersFloat parameters, Decoder decoder,LossFunction lossFunction,InstanceMapping instanceMapping, int goldBeam) {
		super(options, symTab, oracle, transitionFilter, instances, featureExtractor, l2i, parameters, decoder, lossFunction, instanceMapping,goldBeam);
	}
	
	boolean isCorrectAction(ITransition action, State state, Instance inst) {
		if(state.totalTransitions>=inst.transSequence.length)
			return false;
		if(inst.transSequence[state.totalTransitions]==action.getId())
			return true;
		else
			return false;
	}
	
	List<ITransition> getCorrectTransitions(State lastCorrect, Instance inst) {
		return Collections.singletonList(symTab.transition2label[inst.transSequence[lastCorrect.totalTransitions]]);
	}

}
