package ims.trans.doc;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import ims.data.Document;
import ims.data.ISentence;
import ims.io.DocumentWriter;
import ims.io.ReaderWriterFactory;
import ims.io.SentenceReader;
import ims.trans.Options;

public class Regular2Document {

	public static void main(String[] args) throws IOException{
		Options options=new Options(args);
		if(options.docID==null){
			throw new Error("Need to specify docID");
		}
		
		Document<?> d=readFileAsDocument(options.format.sentenceClass,options.train,options.docID);
		DocumentWriter writer=new DocumentWriter(options.out);
		writer.write(d);
		writer.close();
	}
	
	public static <T extends ISentence> Document<T> readFileAsDocument(Class<T> sentenceClass,File input,String dID){
		SentenceReader<T> reader=ReaderWriterFactory.getReader(input, sentenceClass);
		List<T> sList=new ArrayList<>();
		List<String> sIDs=new ArrayList<>();
		int sid=1;
		for(T s:reader){
			sList.add(s);
			sIDs.add(Integer.toString(sid++));
		}
		Document<T> d=new Document<T>(sList,sIDs,dID);
		return d;
	}
	
}
