package ims.trans.features;

import ims.hotcoref.symbols.SymbolTable;
import ims.trans.FeatureExtractor;
import ims.trans.Options;

public class FeatureExtractorFactory {

	public static FeatureExtractor getExtractor(SymbolTable symTab,Options options){
		int stagBits=symTab.stags==null?0:symTab.stags.getBits();
		switch(options.fs){
		case Default:   return new FS_Default(symTab.forms.getBits(),symTab.tags.getBits(),symTab.feats.getBits(),symTab.transitions.getBits(),symTab.deprels.getBits(),stagBits);
		case Standard:  return new FS_Standard(symTab.forms.getBits(),symTab.tags.getBits(),symTab.feats.getBits(),symTab.transitions.getBits(),symTab.deprels.getBits(),stagBits,options.useStag,options.useStack);
		case DumbStandard: return new FS_DumbStandard(symTab.forms.getBits(),symTab.tags.getBits(),symTab.feats.getBits(),symTab.transitions.getBits(),symTab.deprels.getBits(),stagBits);
		case DStandard: return new FS_DStandard(symTab.forms.getBits(),symTab.tags.getBits(),symTab.feats.getBits(),symTab.transitions.getBits(),symTab.deprels.getBits(),stagBits,options.useStag,options.useStack);
		case Eager:
		default: throw new Error("not implemented");
		}
	}
}
