package ims.trans.transitions;

import ims.data.Instance;
import ims.hotcoref.symbols.SymbolTable;
import ims.oracle.Configuration.TR;
import ims.trans.State;

public class DefaultDocSwapStandardFilter extends DefaultArcStandardSwapTransitionFilter{

	private static final long serialVersionUID = -4282079304382449834L;

	final int[] SH_SB;

	
	public DefaultDocSwapStandardFilter(SymbolTable symTab) {
		super(symTab);
		SH_SB=new int[2]; int a=0;
		for(int i=2;i<symTab.transition2label.length;++i){
			ITransition tr=symTab.transition2label[i];
			TR t=tr.getTR();
			int id=tr.getId();
			if(t==TR.SH || t==TR.SB){
				SH_SB[a++]=id;
			}
		}
	}
	
	@Override
	public int[] getAllowedTransitions(State s, Instance inst) {
		if(s.tail==null && s.bufferSize()>0 && s.buf.getNoPushedBack()==0 && s.peekBuffer(0)>1 && s.lastAction!=null && s.lastAction.getTR()!=TR.SB){
			return SH_SB;
		}else{
			return super.getAllowedTransitions(s, inst);
		}
	}

}
