package ims.trans.transitions;

import java.util.List;

import ims.data.Instance;
import ims.hotcoref.symbols.SymbolTable;
import ims.oracle.DeterministicModelOracle;
import ims.oracle.IOracle;
import ims.trans.Options;
import ims.trans.Options.Oracle;
import ims.trans.labelfilter.LBLFilter;

public class TransitionFilterFactory {

	public static ITransitionFilter getTransitionFilter(SymbolTable symTab,List<Instance> instances,boolean posFiltered,boolean withSwap){
		if(posFiltered){
			if(withSwap)
				return new POSArcStandardSwapTransitionFilter(symTab,instances);
			else
				return new POSArcStandardTransitionFilter(symTab,instances);
		} else {
			if(withSwap)
				return new DefaultArcStandardSwapTransitionFilter(symTab);
			else
				return new DefaultArcStandardTransitionFilter(symTab);
		}
	}
		
	public static ITransitionFilter getTransitionFilter(SymbolTable symTab,	List<Instance> instances, Options options,IOracle oracle) {
		if(options.oracle==Oracle.Model){
			return ((DeterministicModelOracle) oracle).getTransitionFilter(symTab,instances);
		}
		boolean posFiltered=options.labelFilter==LBLFilter.POS;
		boolean withSwap=oracle.canDoNonProj();
		return getTransitionFilter(symTab, instances, posFiltered,withSwap);
	}
	
	public static ITransitionFilter getDocumentTransitionFilter(SymbolTable symTab){
		return new DefaultDocSwapStandardFilter(symTab);
	}
	
}
