package ims.util;

public class Accuracy {

	public final int total;
	public final int correct;
	
	public Accuracy(MutableInt total,MutableInt correct){
		this.total=total==null?0:total.getValue();
		this.correct=correct==null?0:correct.getValue();
	}
	
	public Accuracy(int total,int correct){
		this.total=total;
		this.correct=correct;
	}
	
	public double percentage(){
		return 100.d*correct/total;
	}
	
	public static final int MAXWIDTH=5;
	
	public String toString(){
		String format="%"+MAXWIDTH+"d / %"+MAXWIDTH+"d = %5.2f%%";
		return String.format(format,correct,total,percentage());
	}
	
}
