package ims.util.visualtrans;

import java.io.FileOutputStream;
import java.io.IOException;

import com.googlecode.whatswrong.NLPInstance;

import ims.oracle.Configuration;
import ims.oracle.Configuration.TR;
import ims.util.Util;

public class ToyExample {

	
	
	public static void main(String[] args) throws IOException{
		String[] forms={"R","a","b","c","d"};
		String[] ops={"sh","sh","la","sh","ras","sh","ras","ras"};
		Configuration c=new Configuration(new int[forms.length]);
		WhatsWrongExport export=new WhatsWrongExport();
		String outPrefix="./foo-test";
		for(int o=0;o<ops.length;++o){
			makeImage(forms, c, export, outPrefix, o);
			c.applyTR(TR.valueOf(ops[o].toUpperCase()));
		}
		makeImage(forms, c, export, outPrefix, ops.length);
	}

	private static void makeImage(String[] forms, Configuration c, WhatsWrongExport export, String outPrefix, int o) throws IOException {
		FileOutputStream fos=new FileOutputStream(outPrefix+"."+Util.padZerosFront(4, o)+".png");
		NLPInstance nlpInstance=WhatsWrongExport.getNLPInstance(forms, c.getPredHeads(),true,null);
		export.exportToPNG(fos, nlpInstance, 1.d);
		fos.close();
	}
	
}
